# -*- Mode: Python; tab-width: 4 -*-

import dynscroll
import string
import textwin

class output_window (textwin.text_window):

	def append_output (self, lines):
		ll = len (self.lines)
		lines = map (textwin.clean, lines)
		if self.lines[0]:
			self.lines[-1] = self.lines[-1] + lines[0]
		self.lines = self.lines + lines[1:]
		nl = len(self.lines)

		self.adjust_scrollbars()

		# maybe scroll window
		ww, wh = self.size
		fw, fh = self.get_cell_size()

		visible = (wh+fh-1)/fh
		if len(self.lines) > visible:
			#self.oso.write ('visible= %s\n' % repr(visible))
			vs, hs = self.get_scroll_bars()
			#self.oso.write ('vs= %s\n' % repr(vs))
			n, d = vs.get_scroll_position()
			#self.oso.write ('n,d=%d,%d nl=%d\n' % (n,d,nl))
			n = len(self.lines) - visible + 2
			vs.set_scroll_position ((n, len(self.lines)))

		self.invalidate_line_range (ll-1, nl)

	visible = 0

	def check_visible (self):
		if not self.visible:
			self.get_parent().show_window()
			self.visible = 1

	def WM_MOUSEMOVE (self, wparam, lparam):
		self.set_focus()

	def WM_CHAR (self, wparam, lparam):
		print 'char', wparam, lparam

	def do_paint (self, dc):
		textwin.text_window.do_paint (self, dc)

	def write (self, data):
		self.check_visible()
		lines = string.split (data, '\n')
		lines = map (textwin.clean, lines)
		self.append_output (lines)

	def writelines (self, lines):
		self.check_visible()
		lines = map (textwin.clean, lines)
		self.append_output (lines)

	def flush (self):
		pass

	softspace = 0

def make_output_window (name='output window'):
	frame = dynscroll.scroll_frame (name).create()
	w = output_window ('text window', parent=frame).create()
	frame.configure (w, ((0,100), (0,100)))
	return w

if __name__ == '__main__':
	import msgloop
	import sys

	w = make_output_window()
	oso = sys.stdout
	sys.stdout =  w

	def demo_thunk (oso=oso):
		for i in range (10):
			print i
			
		return 3141

	w.oso = oso
	w.create_thunk = demo_thunk
	w.lines = ['test', 'one', 'two', 'three']

	w.get_parent().show_window()

	msgloop.go()
